/* Script generated by Pawn Studio */

#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <hamsandwich>
#include <xs>
#include <engine>

#define PLUGIN	"nyan"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

enum LAST_STRUCT {
	_:LAST_WEAPON,
	_:LAST_AMMO
}

new bool:nayanMode[ 33 ];

new bool:songStarted[ 33 ];

new nayanSong[] = "nayan.mp3";

new spriteTrail[] = "sprites/trailNayan.spr";
new spriteHead[] = "sprites/nayan.spr";

new lastWeaponStruct[ 33 ][ LAST_STRUCT ];

new trailPointer;

new Float:fMins[] = { 1.0 , 1.0 , 1.0 },
	Float:fMaxs[] = { 1.0 , 1.0 , 1.0 };

public plugin_init(){
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_clcmd( "say /nayan" , "nayanCat" );
	
	register_event("CurWeapon","Event_CurWeapon", "b");
}

public plugin_precache(){
	precache_sound( nayanSong );
	
	trailPointer = precache_model( spriteTrail );
	precache_model( spriteHead );
}

public nayanCat( id ){
	nayanMode[ id ] = !nayanMode[ id ];
}

public client_connect( id ){
	nayanMode[ id ] = false;
	
	lastWeaponStruct[ id ][ LAST_WEAPON ] = 0;
	lastWeaponStruct[ id ][ LAST_AMMO ] = 0;
}

public Event_CurWeapon( id ){ 
	if( !is_user_alive( id ) || !nayanMode[ id ] ){
		return PLUGIN_CONTINUE;
	}
	
	new gunId = read_data( 2 );
	
	if( !gunId || gunId == 6 || gunId == 29 || gunId > 30){
		return PLUGIN_CONTINUE;
	}
	
	new currentAmmo = read_data( 3 );
	
	if( lastWeaponStruct[ id ][ LAST_WEAPON ] != gunId ){
		
		lastWeaponStruct[ id ][ LAST_WEAPON ] 	=	gunId;
		lastWeaponStruct[ id ][ LAST_AMMO ]		=	currentAmmo;
		
		songStarted[ id ] = false;
		
		return PLUGIN_CONTINUE;
	}
	
	if( lastWeaponStruct[ id ][ LAST_AMMO ] <= currentAmmo ){
		lastWeaponStruct[ id ][ LAST_AMMO ]		=	currentAmmo;
		
		songStarted[ id ] = false;
		
		return PLUGIN_CONTINUE;
	}
	
	lastWeaponStruct[ id ][ LAST_AMMO ]	=	currentAmmo;
	
	if( !songStarted[ id ] ){
		playNayan( id );
	}
	
	createHead( id );
	
	return PLUGIN_CONTINUE;
}

public playNayan( id ){
	songStarted[ id ] = true;
	
	new szCommand[ 64 ];
	
	formatex( szCommand , charsmax( szCommand ) , "mp3 play sound/%s" , nayanSong );
	
	client_cmd( id , szCommand );
}

public stopNayan( id ){
	songStarted[ id ] = false;
	
	client_cmd( id , "mp3 stop" );
}

public createHead( id ){
	new iEnt = engfunc( EngFunc_CreateNamedEntity , engfunc( EngFunc_AllocString  , "env_sprite" ) );
	
	if( !pev_valid( iEnt ) ){
		return;
	}
	
	set_pev( iEnt , pev_classname , "nayanHead" );
	
	set_pev( iEnt , pev_solid , SOLID_TRIGGER );
	set_pev( iEnt , pev_movetype , MOVETYPE_FLY );
	
	new Float: angleViews[ 3 ],
		Float: angleViewsSecond[ 3 ],
		Float: fForwardVector[ 3 ],
		Float: fPosition[ 3 ],
		Float: fViewOfs[ 3 ];
	
	pev( id , pev_angles , angleViewsSecond );
	pev( id , pev_v_angle , angleViews );
	pev( id , pev_origin , fPosition );
	pev( id , pev_view_ofs , fViewOfs );
	
	angle_vector( angleViews , ANGLEVECTOR_FORWARD , fForwardVector );
	
	xs_vec_normalize( fForwardVector , fForwardVector );
	
	xs_vec_mul_scalar( fForwardVector , 750.0 , fForwardVector );
	
	xs_vec_add( fPosition , fViewOfs , fPosition );
	
	set_pev( iEnt , pev_scale , 0.05 );
	
	set_pev( iEnt , pev_velocity , fForwardVector );
	
	set_pev( iEnt , pev_angles ,  angleViewsSecond );
	
	set_pev( iEnt , pev_owner , id );
	
	engfunc( EngFunc_SetOrigin , 	iEnt , fPosition );
	engfunc( EngFunc_SetModel , 	iEnt , spriteHead );
	engfunc( EngFunc_SetSize ,		iEnt , fMins , fMaxs );
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_BEAMFOLLOW)
	write_short( iEnt )
	write_short( trailPointer )
	write_byte( 10 )
	write_byte( 5 )
	write_byte( 255 )
	write_byte( 255 )
	write_byte( 255 )
	write_byte( 192)
	message_end()
	
	RegisterHamFromEntity( Ham_Touch , iEnt , "hwdTouch" , true );
}

public hwdTouch( iEnt , iTouched ){	
	if( !pev_valid( iEnt ) ){
		return HAM_IGNORED;
	}
	
	if( iTouched == pev( iEnt , pev_owner ) ){
		return HAM_IGNORED;
	}
	
	remove_entity( iEnt );
	
	return HAM_IGNORED;
}